/*  -*- Mode: Asm -*-  */
/*
    negsf2.S is part of     FPlib V 0.3.0       ported to avr-as
    for copyright and details see readme.fplib

 *----------------------------------------------------------------------------------------
 * negate  A = -A
 */

#include "gasava.inc"
#include "fplib.inc"

          TEXT_SEG(fplib, __negsf2)
          FUNCTION(__negsf2)

GLOBAL(__negsf2)
     ADD     rA2,rA2
     ADC     rA3,rA3
     BREQ    ___negsf2_100
     SBC     rT0,rT0        ; if C = 1 (negative) -> rT0 = 0xFF = ~0
                            ; if C = 0 (positive) -> rT0 = 0x00 = ~0xFF
     COM     rT0
     ROR     rT0
 ___negsf2_100: ; zero, negate
     ROR     rA3
     ROR     rA2
     RET

          ENDFUNC


